#include "yaml-cpp/yaml.h"
#include <vector>
#include <caf/all.hpp>
#include "caf/io/all.hpp"

using namespace caf;

// Define some message atoms
CAF_BEGIN_TYPE_ID_BLOCK(my_project, caf::first_custom_type_id)

  CAF_ADD_ATOM(my_project, some_atom)
  CAF_ADD_ATOM(my_project, some_other_atom)

CAF_END_TYPE_ID_BLOCK(my_project)


behavior some_actor(event_based_actor* self) {


    return {
        [=](some_atom) {
            aout(self) << "received some_atom\n";
        },
    };
}



void caf_main(actor_system& system) {
    scoped_actor self{system};
    YAML::Node config;

    try {
        YAML::Node config = YAML::LoadFile("config.yaml");
    } catch (const std::exception& e) {
        aout(self) << "Library Error: " << e.what() << "\n";
        aout(self) << "Check if File Exists\n";
    }

    aout(self) << "config = " << config << "\n";

    auto some_actor_ref = self->spawn(some_actor);
    self->send(some_actor_ref, some_atom_v);

    // std::vector<int> val_1 = config["some_val"].as<std::vector<int>>();
    // aout(self) << "val_1 = " << val_1 << "\n";

}

int main() {
    caf::exec_main_init_meta_objects<io::middleman, id_block::my_project>();                           
    caf::core::init_global_meta_objects(); 
    int dummy_argc = 0;
    char** dummy_argv = nullptr;
    return caf::exec_main<>(caf_main, dummy_argc, dummy_argv);
}


// CAF_MAIN(io::middleman, id_block::my_project)